#include "History.hpp"

#include <iostream>

bool History::Table::has(const Move& move) {
    auto it = table.find(move.pair());

    return it != table.end();
}

void History::Table::add(const Move& move) {
    if (has(move)) throw 1; // todo: real

    table[move.pair()] = 1;
}

void History::Table::remove(const Move& move) {
    if (!has(move)) throw 1;

    table.erase(move.pair());
}

UNumber History::Table::get(const Move& move) {
    if (has(move)) return table[move.pair()];

    return from_table[move.from] / 256 + to_table[move.to] / 16;
}

void History::Table::renew(const Move& move, Score alpha, Score beta, Score score) {
    if (!(score >= alpha) || alpha <= -100000) return;

    if (has(move)) {
        table[move.pair()]++;
    } else {
        add(move);
    }

    from_table[move.from] = from_table[move.from] + 1;
    to_table[move.to] = to_table[move.to] + 1;
}

