#ifndef RESTORE_DATA
#define RESTORE_DATA

#include <list>

#include "Coord.hpp"
#include "Board.hpp"

class Action {
public:
    static Action move(const Coord&, const Coord&);
    static Action set(const Piece&, const Coord&);
    static Action remove(const Coord&);

    void make(Board&);
private:
    enum class ActionType {__MOVE, __SET, __REMOVE};

    Action(ActionType type): type(type) {};
    Coord from, to;
    Piece captured;
    Coord capture_coord;

    ActionType type;
};

class RestoreData {
public:
    RestoreData(const EnpassantPosibility&, const RookingPosibility&);

    std::list<Action> restore_actions;
    Coord last_moved;

    void restore(Board&);

    void add_action(const Action&);

private:
    EnpassantPosibility ep;
    RookingPosibility rp;
};

#endif
